import httplib, json
import sys
from base64 import b64encode

defaultPort = 8080
defaultIp = "localhost"
defaultAuth = "admin"
adminRole = ""

if (len(sys.argv) > 4):
	adminRole = sys.argv[1]
	login = sys.argv[2]
	password = sys.argv[3]
	authString = "{}:{}".format(login, password)
	ip_port = sys.argv[4] 
	if(len(ip_port.split(":")) == 2 ): 
		connection = httplib.HTTPConnection(ip_port)
	else:
		connection = httplib.HTTPConnection(defaultIp, ip_port)
elif(len(sys.argv) == 4):
	connection = httplib.HTTPConnection(defaultIp, defaultPort)
	adminRole = sys.argv[1]
	login = sys.argv[2]
	password = sys.argv[3]
	authString = "{}:{}".format(login, password)
elif(len(sys.argv) == 2):
	adminRole = sys.argv[1]
	login = defaultAuth
	connection = httplib.HTTPConnection(defaultIp, defaultPort)
	authString = "{}:{}".format(defaultAuth, defaultAuth)
else:
	print ("You should enter userRoleName")
	sys.exit()
userAndPass = b64encode(authString).decode("ascii")
connection.connect()
stringQuery = "/CSrest/rest/v2/userRoles"
headers = {'Accept': 'application/json', 'Content-Type': 'text/plain', 'Authorization' : 'Basic %s' % userAndPass}
print ("Change rules for userRole: " + adminRole)
connection.request("POST", stringQuery + "/get/id", adminRole, headers)
response=connection.getresponse()
data = response.read()
if not data:
	sys.exit("UserRole {} not found".format(adminRole))
if response.status == 200:
	print ("UserRole {} found".format(adminRole))
else:
	sys.exit("Error. Code {}".format(response.status))
responseObject = json.loads(data)

responseObject["userRights"]["ADMIN_PUPPET_CLASS"]["value"] = not responseObject["userRights"]["ADMIN_PUPPET_CLASS"]["value"]
headers = {'Content-Type': 'application/json', 'Authorization' : 'Basic %s' % userAndPass}
params = {'id' : adminRole, 'object' : responseObject}
connection.request("PUT", stringQuery + "/update/id?fields=userRights", json.dumps(params), headers)
response=connection.getresponse()
if response.status == 200:
	print ("UserRules for {} updated ".format(adminRole))
else:
	sys.exit("Error {}".format(response.status))
connection.close()

