# -*- coding: UTF-8 -*-

import re
import json
import traceback

VALUES_KEY = 'values'

ignoreTables = ['tmc', 'barcodes', 'discountsystem', 'disccard', 'discountsauto', 'sprices', 'tmcsalerestrict', 'tprices', 'hotkey', 'hotkeyinvent']

def dropCommandMenuObjects(result):
    # сейчас в дампе есть меню "Чек", но оно устарело и не используется. При актуализации дампа на кассе эта запись будет удалена, надо будет удалить и эту проверку
    for obj in result.get('menu', {}).get('objects', []):
        if obj.get('menuname', None) == 'Чек':
            result['menu']['objects'].remove(obj)
            break
    # исключим из импорта все действия и параметры, связанные с COMMAND_MENU (эти действия будут создаваться при импорте справочника "Меню")
    commandCode = None
    for obj in result.get('command', {}).get('objects', []):
        if obj.get('commandname', None) == 'COMMAND_MENU':
            commandCode = obj.get('commandcode', None)
    cmActions = []
    cmActionCodes = []
    i=0
    while i < len(result.get('cmaction', {}).get('objects', [])):
        if result.get('cmaction', {})['objects'][i].get('commandcode', None) == commandCode:
            cmActions.append(result['cmaction']['objects'][i])
            cmActionCodes.append(result['cmaction']['objects'][i].get('cmactioncode', None))
            del result['cmaction']['objects'][i]
        else:
            i += 1
    i=0
    actionParameters = []
    while i < len(result.get('actionparameter', {}).get('objects', [])):
        if result.get('actionparameter', {})['objects'][i].get('cmactioncode', None) in cmActionCodes:
            actionParameters.append(result['actionparameter']['objects'][i])
            del result['actionparameter']['objects'][i]
        else:
            i += 1
    result['command_menu_cmaction'] = {'objects': cmActions, 'columns': (result.get('cmaction', {}).get('columns', []))}
    result['command_menu_actionparameter'] = {'objects': actionParameters, 'columns': (result.get('actionparameter', {}).get('columns', []))}

result = {}
tableName = ''
# сюда будем накапливать строку со значениями для одной таблицы
valuesStr = ''
# признак того, что ищем значения для таблицы после нахождения "insert into"
findValues=False
try:
    dump = open('/opt/cashserver/defaultdictionaries/dictionaries-lite.sql')
    for l in dump.readlines():
        line = l.strip()
        # пропускаем строки с коментариями
        if line.startswith('#'):
            continue
        lowerLine = line.lower()
        if line:
            if lowerLine.startswith('insert into'):
                tableName = re.search('`(.*)`', line[:line.find('(')]).group(1)
                if not tableName in ignoreTables:
                    columns = line[line.find('(')+1 : line.find(')')].replace('`', '').replace(' ', '').split(',')
                    print(tableName)
                    findValues=True
            if findValues:
                if not valuesStr:
                    # найдем с какой позиции строки начинается перечисление значений
                    startValuesPos = lowerLine.find(VALUES_KEY)
                    if startValuesPos != -1:
                        valuesStr = line[startValuesPos+len(VALUES_KEY):]
                        # если нашли слово values, значит начали собирать значения, если значений еще не нашли, то просто заполним пробелом строку, чтобы знать что мы уже собираем значения
                        if not valuesStr:
                            valuesStr = ' '
                else:
                    # если в строках со значениями есть коментарии, то уберем эти коменты
                    if re.search("\)[\s]*[,;][\s]*(#.*)", line):
                        line = line[:line.rfind('#')].strip()
                    valuesStr += line
                if line.endswith(';') and valuesStr:
                    values = eval(valuesStr[:-1].replace('NULL', 'None') + ',')
                    valuesStr = ''
                    findValues = False
                    objects = []
                    for v in values:
                        objects.append(dict(zip(columns, v)))
                    result[tableName] = {'objects': objects, 'columns': columns}
    dropCommandMenuObjects(result)


    out = open('/opt/cashserver/defaultdictionaries/dictionaries-full.json', 'w')
    out.write(json.dumps(result, ensure_ascii=False, sort_keys=True, indent=4))

    dump.close()
    out.close()
except:
    print("can't convert mysql dump to json")
    print(traceback.format_exc())
